/**
 * Script to add achievements in-game. Player who reaches first XX points wins.
 */

/// specify the savegame to load
map.file = "online.sve"

/// short description to be shown in finance window
/// and in standard implementation of get_about_text
scenario.short_description = "Regions"
scenario.author = "dwachs and Yona-TYT"
scenario.version = "2.0"
scenario.translation      <- "Yona-TYT"

const save_version = 1

//Coordenadas para eliminar construcciones
removercoord <-	[{x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}, {x=null, y=null, z=null}]

//Coordenadas para añadir construcciones
addcoord <-	[{x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}, {x1=null, y1=null, z1=null, x2=null, y2=null, z2=null, px=null, py=null}]

//Coordenadas para compartir region
save_reg	<- [{x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}, {x1=null , y1 = null , x2=null, y2=null}]


//Permiso de jugadores
play_per <-	[array(12), array(12), array(12), array(12), array(12), array(12), array(12), array(12), array(12), array(12), array(12), array(12)]
g_sign <-	array(14)

savetxt  <- [(""),(""),(""),(""),(""),(""),(""),(""),(""),(""),(""),("")]
remover  <- null
savbuild   <- [{way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0}, {way=null, waycont=0, pw=null, pwcont=0} ]


clime    <- null
climesw  <- null
globtool <- null
swcl     <- null
swnr     <- null
shared   <- null
swpl     <- array(13)

include("regions")

function get_info_text(pl)
{
	local info = ttextfile("info.txt")
	local text = ttext("")
	local plnr = null
	local plsave = null

	local c_res = ""
	local pl_res = ""

	local num = totalpl[0].tl

	info.coor = c_res
	info.list = pl_res
	info.sreg = ttext("")

 	info.gp = ttext(get_player_text(pl,""))
	
	return info.tostring()
}
function get_rule_text(pl)
{
	local num = totalpl[0].tl
	
	local rule = ttextfile("rule.txt")
	if (pl==1)
		rule = ttextfile("rule_pub.txt") 
	
	if (pl==1){
		rule.st1pub = ttext("<a href=\"("+coord_label1pub[0].x+","+coord_label1pub[0].y+")\">" + translate("Text label") + " ("+(coord_label1pub[0].x )+"," + ""+coord_label1pub[0].y+") </a>")
	}

	if (pl>1 && g_sign[pl-2]){
		rule.label1 = ttext("<a href=\"("+coord_label1[pl-2].x+","+coord_label1[pl-2].y+")\">" + translate("Text label") + " ("+(coord_label1[pl-2].x )+"," + ""+coord_label1[pl-2].y+") </a>") 

		rule.sign = ttext("<a href=\"("+(g_sign[pl-2].x + 1)+","+g_sign[pl-2].y+")\">" + " ("+(g_sign[pl-2].x + 1)+"," + ""+g_sign[pl-2].y+") </a>")
	}
	else{
		rule.label1 = ttext(translate("<em>Text label</em>"))
		rule.sign = ttext("")
	}
	return rule.tostring()
}

function get_result_text(pl)
{
	local result = ttextfile("result.txt")
	return result.tostring()
}
function get_goal_text(pl)
{
	local goal = ttextfile("goal.txt")
	return goal.tostring()
}


function is_scenario_completed(pl)
{
//Para configutar los bordes
//-----------------------------------------------------------------------------------------------------------
  local num = totalpl[0].tl
  
  if (pl == 1 && get_bord(pl) != null && clime !=2)clime=1
  if (swcl != bordsave[0].cl || swnr != bordsave[0].nr)clime=1
  else clime=null
  if (clime ==2) climesw = 1

  if (clime == 1 || climesw == 1) {
	  swcl = bordsave[0].cl
	  swnr = bordsave[0].nr			
	  totalpl[0].tl = bordsave[0].nr

	  if (climesw==1) get_coordyxpl(0)
	  else if (clime==1) get_coordyxpl(1)
	  get_bord_map(0)

	  clime=null
	  climesw=null
	  return null
  }

//Para las regiones
//------------------------------------------------------------------

  local tile_pub = square_x(coord_label1pub[0].x, coord_label1pub[0].y).get_ground_tile()
  if (pl == 1 && !tile_pub.find_object(mo_label)){
	  
	  local t1 = command_x(tool_remover)
	  local err1 = t1.work(player_x(1), tile_pub, "")

	  local c_label = tile_pub
	  label_x.create(c_label, player_x(pl), translate("Clime nr,Region Siz"))
	  player_x(pl).book_cash(10000)
  }

//-----------------------------------------------------
  if ((pl-2)<num && pl!=0 && pl!=1 && pl!=14){
    
	  local tile = square_x(coord_label1[pl-2].x, coord_label1[pl-2].y).get_ground_tile()
	  local label = tile.find_object(mo_label)
	  
	  local gr_tilea = square_x(coord_label1[pl-2].x+1, coord_label1[pl-2].y).get_ground_tile()
	  local gr_tileb = square_x(coord_label1[pl-2].x+1, coord_label1[pl-2].y+1).get_ground_tile()
	  g_sign[pl-2] = gr_tilea
	  
	  local sign = gr_tilea.find_object(mo_roadsign)
	  if(sign){
		  sign.can_pass(player_x(pl)) 	
	  }
	  
	  else if (!label){
	    while(!gr_tilea.is_empty() || !gr_tileb.is_empty() || !tile.is_empty()){
	      local t1 = command_x(tool_remover)
	      local err = t1.work(player_x(1), gr_tilea, "")
	      err = t1.work(player_x(1), gr_tileb, "")
	      err = t1.work(player_x(1), tile, "")
	    } 
	  }

	  else if(gr_tilea.get_slope()!=0 ){
	    command_x.set_slope(player_x(1), gr_tilea, slope.all_up_slope)	 
	  }
	  else if (gr_tileb.get_slope()!=0){
	    command_x.set_slope(player_x(1), gr_tileb, slope.all_up_slope)
	  }
	  else if(square_x(gr_tilea.x, gr_tilea.y).get_climate()==0){
	    command_x.set_slope(player_x(1), gr_tilea, slope.all_up_slope)
	  }
	  else if(gr_tileb.z<gr_tilea.z){
	    command_x.set_slope(player_x(1), gr_tileb, slope.all_up_slope)
	  }

	  else if(gr_tileb.z>gr_tilea.z){
	    command_x.set_slope(player_x(1), gr_tileb, slope.all_down_slope)
	  }
	  else if(!gr_tilea.find_object(mo_way) || !gr_tileb.find_object(mo_way)){
	    local t2 = command_x(tool_build_way)
	    local err = t2.work(player_x(1), gr_tilea, gr_tileb, "dirt_road")

	  }
	  else if(!sign){
	    local t = command_x(tool_build_roadsign)
	    local err = t.work(player_x(pl), gr_tilea, "Roadgate")
	    player_x(pl).book_cash(50000)
	  }

	  local tile = square_x(coord_label1[pl-2].x, coord_label1[pl-2].y).get_ground_tile()
	  if (playersave[pl-2].plsave==null && !tile.find_object(mo_label)){
		  local c_label = tile
		  label_x.create(c_label, player_x(pl), translate("Share region here"))
		  player_x(pl).book_cash(10000)
	  }
	  else if (playersave[pl-2].plsave!=pl+1 && !tile.find_object(mo_label)){
		  local c_label = tile
		  label_x.create(c_label, player_x(pl), ""+(playersave[pl-2].plsave-1)+"")
		  player_x(pl).book_cash(10000)
	  }
//----------------------------------------------------------------------------------------------------------------
	  local rem_building = tile_x(removercoord[pl-2].x, removercoord[pl-2].y, removercoord[pl-2].z)
	  local add_way= tile_x(addcoord[pl-2].x1, addcoord[pl-2].y1, addcoord[pl-2].z1)

	  if (remover == 1){

	    //Remover marcadore de posicion
	    if (rem_building.find_object(mo_label)){		
	      if (globtool != 4096 && globtool != 4102){
		rem_building.remove_object(player_x(1),mo_label)
		remover = null																		
	      }
	    }
		//Elimina una estacion y resta -1,000.00 de efectivo
	    if (rem_building.find_object(mo_building)){
								
		rem_building.remove_object(player_x(1),mo_building)			// elimina la estacion		
		player_x(pl).book_cash(-100000)						//Resta -100000
		remover = null						

	    }
	}

  //Vias de tren publicas
  //--------------------------------------------------------------------------------------------------------------------------------------------------
		  
	  if (savbuild[pl-2].way == 3){
		  local tile1 = square_x(addcoord[pl-2].x1, addcoord[pl-2].y1).get_ground_tile()
		  local tile2 = square_x(addcoord[pl-2].x2, addcoord[pl-2].y2).get_ground_tile()
		  
		  local way= add_way.find_object(mo_way)
		  if (add_way.find_object(mo_way))way= way.get_waytype()
		  if (way== wt_rail){
		  local t1 = command_x(tool_build_way)
		  local err1 = t1.work(player_x(1), tile1, tile2, "sand_track")
		  }
		  if (way== wt_road){
		  local t1 = command_x(tool_build_way)
		  local err1 = t1.work(player_x(1), tile1, tile2, "dirt_road")
		  }
		  if (way== wt_water){
		  local t1 = command_x(tool_build_way)
		  local err1 = t1.work(player_x(1), tile1, tile2, "Kanal")
		  }
		  savbuild[pl-2].way = null
	  }
  //--------------------------------------------------------------------------------------------------------------------------------------------------
    return 1
  }
}

function is_work_allowed_here(pl, tool_id, pos)
{
  return is_work_regions(pl, tool_id, pos)
}


//Para las regiones
//------------------------------------------------------------------------

// Se obtienen lo valores de coordenadas y los nr de jugadores
regionshare <- {
	plsavesave = playersave
	stationcoordsav = save_reg
	sws = sw
	total = totalpl
	bord = bordsave
	swspl = swpl
	build_pub = savbuild
}

class data_share {
	
	
	// Numeros de los jugadores 
	function get_plsave() {return regionshare.plsavesave }

	// Coordenadas compartidas
	function get_save_reg() {return regionshare.stationcoordsav }

	// Guarda sw
	function get_sw() {return regionshare.sws }

	function get_totalpl() {return regionshare.total }
	
	function get_bord() {return regionshare.bord }

	function get_swspl() {return regionshare.swspl }

	function get_build() {return regionshare.build_pub }

	// Se guardan los datos
	function _save() { return "data_share()"; }
}

//------------------------------------------------------------------------

persistent <- {
	regionshare = regionshare
}

function start()
{
	get_coordyxpl(0)
	
	
	persistent.save_version <- save_version
	
}

function is_tool_allowed(pl, tool_id, wt)
{
	return true
}

function resume_game()
{
  gui.open_info_win_at("goal")
  get_coordyxpl(0)
  // save game version
  if ( !("save_version" in persistent) ) {
	  persistent.save_version <- 0
  }

// Datos guardados para las regiones
//-----------------------------------------------------
		
    // copy it piece by piece otherwise the reference 
    foreach(key,value in persistent.regionshare){
      regionshare.rawset(key,value)
    }
    persistent.regionshare = regionshare

    // Se obtienen los datos guardados
    playersave  = data_share().get_plsave()
    save_reg = data_share().get_save_reg()
    sw = data_share().get_sw()
    totalpl = data_share().get_totalpl()
    bordsave = data_share().get_bord()
    swpl = data_share().get_swspl()


//-------------------------------------------------------
if(bordsave[0].nr)
  totalpl[0].tl = bordsave[0].nr
  
  persistent.save_version = save_version
}

//------------------------------------------------------------------------------------------------------------------------------------------------

xmin  <- 0
xmax  <- 0
ymin  <- 0
ymax  <- 0

gtpla <- null
gtplb <- null

function is_work_regions(pl, tool_id, pos)
{									 	
	local tile = tile_x(pos.x, pos.y, pos.z)
	local build = tile.find_object(mo_building)	
	local label = tile.find_object(mo_label)
	local way = tile.find_object(mo_way)
	local bridge = tile.find_object(mo_bridge)
	local power = tile.find_object(mo_powerline)
	local result = translate("This region belongs to another player!.")  	// set standard error message
	if (tool_id == 4096) return null
	if (pl==1)  return result = null
	else result = translate("This region belongs to another player!.") 
	if (  pl==0 || pl==14) return result
	//local result2 = 0
	
	local num = totalpl[0].tl

	if ((pl-2)<num && pl!=0 && pl!=1 && pl!=14) {
	  
	  	if (pos.x==g_sign[pl-2].x && pos.y == g_sign[pl-2].y)
	  return translate("Action not allowed") + " ("+pos.x+","+pos.y+")."
	else if (pos.x==coord_label1[pl-2].x && pos.y == coord_label1[pl-2].y)
	  return translate("Action not allowed") + " ("+pos.x+","+pos.y+")."
	  
		csizx  = sizx/2	
		csizy  = sizy/2		
		playernr(pl)
		result = translate("Just you can use this tool in your region!") + " ("+(pl_reg[pl-2].x2-csizx)+","+(pl_reg[pl-2].y2+csizy)+")."
		
		//Elimina cualquier objeto, siempre que el jugador sea el propietario
		foreach(obj in tile.get_objects()) {	  
		  if (obj.get_owner().nr == pl){	
		    if (tool_id == 4097 || tool_id == 4096)return result = null
		    else result = translate("This region belongs to another player!.")	  
		  }
		}
							
		if (pos.x+1 >= pl_reg[pl-2].x1 && pos.x <= pl_reg[pl-2].x2+1 && pos.y+1 >= pl_reg[pl-2].y2 && pos.y<= pl_reg[pl-2].y1+1 ) {
			result = null
			if (tool_id == 4097){
				  
				if (shared == 1) {
					save_reg[pl-2].x1=pos.x
					save_reg[pl-2].y1=pos.y
					shared = 2
					return result = translate("Coord A:") + " (" +pos.x+","+pos.y+")."
				}
				else if (shared == 2) {
					shared = null
					save_reg[pl-2].x2=pos.x
					save_reg[pl-2].y2=pos.y
					local camb1 = save_reg[pl-2].x1
					local camb2 = save_reg[pl-2].x2												
					if (save_reg[pl-2].x1>save_reg[pl-2].x2) {
						save_reg[pl-2].x1 = camb2
						save_reg[pl-2].x2 = camb1
					}	
					camb1 = save_reg[pl-2].y1
					camb2 = save_reg[pl-2].y2
					if (save_reg[pl-2].y1>save_reg[pl-2].y2) {
						save_reg[pl-2].y1 = camb2
						save_reg[pl-2].y2 = camb1
					}
					return result = translate("Coord B:") + " ("+pos.x+","+pos.y+")."
				}
			}
			local rem_building = tile_x(pos.x, pos.y, pos.z)
			local add_way = tile_x(pos.x, pos.y, pos.z)
			//Para eliminar marcadores de otros jugadores pero dentro de nuestra region
			if (label){
				local nr = map_object_x(pos.x, pos.y, pos.z, mo_label).get_owner().nr
				if (nr == pl) return result = null  //Elimina Si el jugador es el propietario
				if (nr != 1) {
					globtool = tool_id
					removercoord[pl-2].x=pos.x
					removercoord[pl-2].y=pos.y
					removercoord[pl-2].z=pos.z
					remover = 1
					return result = translate("The text was deleted.")
				}
					
			}
			//Para eliminar Estaciones de otros jugadores pero dentro de nuestra region
			if (build) {
				local nr = build.get_owner().nr
				if (nr == pl)
					return result = null  //Elimina Si el jugador es el propietario
				if (tool_id == 4097 && tile.get_halt() != null && build.get_factory() == null){
					globtool = tool_id
					removercoord[pl-2].x=pos.x
					removercoord[pl-2].y=pos.y
					removercoord[pl-2].z=pos.z
					remover = 1											
					return result = translate("You have eliminated the station another player.")	
				}
			}

			//Para eliminar puentes de otros jugadores pero dentro de nuestra region
			if (bridge){
				if (bridge.get_owner().nr == pl)
					return result = null  //Elimina Si el jugador es el propietario
				if (tool_id == 4097) {
					globtool = tool_id
					removercoord[pl-2].x=pos.x
					removercoord[pl-2].y=pos.y
					removercoord[pl-2].z=pos.z
					remover = 1											
					return result = "You have eliminated a bridge another player."		
				}
			}
			// Para construir via de tren publica
			if(tool_id == 4110 && way) { 
				local nr = way.get_owner().nr
				if (savbuild[pl-2].way != 2) {
					if (nr == pl && nr != 1) {
						globtool = tool_id
						addcoord[pl-2].x1=pos.x
						addcoord[pl-2].y1=pos.y
						addcoord[pl-2].z1=pos.z

						savbuild[pl-2].way = 2
						result = null
					}
				}

				if (savbuild[pl-2].way == 2) {
					if (nr != pl && nr != 1) {
						savbuild[pl-2].way = null
						globtool = tool_id
						addcoord[pl-2].x2=pos.x
						addcoord[pl-2].y2=pos.y
						addcoord[pl-2].z2=pos.z
						if (addcoord[pl-2].x1 == addcoord[pl-2].x2) {
							if(pos.y==addcoord[pl-2].y1+1) {
								savbuild[pl-2].waycont++											
								savbuild[pl-2].way = 3 
								return result = translate("Connected!") + " ("+pos.x+","+pos.y+")."
																															
							}
							else if(pos.y==addcoord[pl-2].y1-1) {
								savbuild[pl-2].waycont++												
								savbuild[pl-2].way = 3 
								return result = translate("Connected!") + " ("+pos.x+","+pos.y+")."
							}
						}
						if (addcoord[pl-2].y1 == addcoord[pl-2].y2) {
							if(pos.x==addcoord[pl-2].x1+1) {
								savbuild[pl-2].waycont++								
								savbuild[pl-2].way = 3 
								return result = translate("Connected!") + " ("+pos.x+","+pos.y+")."								
							}
							if(pos.x==addcoord[pl-2].x1-1) {
								savbuild[pl-2].waycont++										
								savbuild[pl-2].way = 3 
								return result = translate("Connected!") + " ("+pos.x+","+pos.y+")."		
							}
						}											
					}
				}
			}
			else savbuild[pl-2].way = null
			result = region_shared2(pl, tool_id, pos, result)
		}
		}
	if (tool_id == 4096 || tool_id == 4102) {
		if ( pos.x != pl_reg[pl-2].x1+6 &&  pos.y != pl_reg[pl-2].y2) result = null
	}
	result = region_shared2(pl, tool_id, pos, result)
	return result
}

function region_shared2(pl, tool_id, pos, result)
{
  for (j=0;j<12;j++) {
    if (j == (pl-2))
      continue
    local tile = square_x(coord_label1[j].x+1, coord_label1[j].y).get_ground_tile()
    
    local sign = tile.find_object(mo_roadsign)
    if(sign){
	
	if (sign.can_pass(player_x(pl))){
	    if (pos.x+1 >= pl_reg[j].x1 && pos.x <= pl_reg[j].x2+1 && pos.y+1 >= pl_reg[j].y2 && pos.y<= pl_reg[j].y1+1 ) {
	      return null
	    }
	}
    }
  }
  return result
}


